#include <WindowsConstants.au3>
#include <GUIConstants.au3>
#include <GDIPlus.au3>
#include <String.au3>
#include <File.au3>

Opt("TrayIconHide", 1)
Opt("GUIOnEventMode", 1)

Global $aNews, $iCurSel = 1, $sNewsType = "Computer"

Global $aImageFilter[6]
$aImageFilter[0] = "wikipedia-logo"
$aImageFilter[1] = "wikinews-logo"
$aImageFilter[2] = "ISO_639_Icon_en"
$aImageFilter[3] = "poweredby_mediawiki"
$aImageFilter[4] = "wikimedia-button"
$aImageFilter[5] = ".svg"

$hWnd = GUICreate("WikiNews - " & $sNewsType, 400, 200)
$cProgress = GUICtrlCreateProgress(50, 90, 300, 20)
GUICtrlSetCursor($cProgress, 1)
$cContext = GUICtrlCreateContextMenu()
$cNewsType = GUICtrlCreateMenu("Newstyp", $cContext)
$cCredits = GUICtrlCreateMenuItem("Credits", $cContext)
$cPolitik = GUICtrlCreateMenuItem("Politik", $cNewsType, -1, 1)
$cWirtschaft = GUICtrlCreateMenuItem("Wirtschaft", $cNewsType, -1, 1)
$cKultur = GUICtrlCreateMenuItem("Kultur", $cNewsType, -1, 1)
$cRecht = GUICtrlCreateMenuItem("Recht", $cNewsType, -1, 1)
$cWissenschaft = GUICtrlCreateMenuItem("Wissenschaft", $cNewsType, -1, 1)
$cUmwelt = GUICtrlCreateMenuItem("Umwelt", $cNewsType, -1, 1)
$cMedien = GUICtrlCreateMenuItem("Medien", $cNewsType, -1, 1)
$cArbeit = GUICtrlCreateMenuItem("Arbeit & Soziales", $cNewsType, -1, 1)
$cComputer = GUICtrlCreateMenuItem("Computer", $cNewsType, -1, 1)
$cSport = GUICtrlCreateMenuItem("Sport", $cNewsType, -1, 1)
GUISetState()

_GDIPlus_Startup()

$hGraphic = _GDIPlus_GraphicsCreateFromHWND($hWnd)
$hBitmap = _GDIPlus_BitmapCreateFromGraphics(400, 200, $hGraphic)
$hBuffer = _GDIPlus_ImageGetGraphicsContext($hBitmap)
_GDIPlus_GraphicsSetSmoothingMode($hBuffer, 2)

$hImageBG = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Images\BG.png")
$hImageCredits = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Images\Credits.png")
$hImageButton_Back = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Images\Back.png")
$hImageButton_Next = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Images\Next.png")
$hImageButton_Read = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Images\read.png")
$hImageButton_BackHover = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Images\Back_Hover.png")
$hImageButton_NextHover = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Images\Next_Hover.png")
$hImageButton_ReadHover = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Images\Read_Hover.png")

$hBrushDate = _GDIPlus_BrushCreateSolid(0xFF6377D0)
$hBrushTitle = _GDIPlus_BrushCreateSolid(0xFF7F7F7F)

$hFamily = _GDIPlus_FontFamilyCreate("Arial")
$hFont = _GDIPlus_FontCreate($hFamily, 8, 1)
$hFormat = _GDIPlus_StringFormatCreate()

$tLayoutDate = _GDIPlus_RectFCreate(10, 13)
$tLayoutNewsText = _GDIPlus_RectFCreate(145, 48, 250, 112)

Global $aButtons[4][8]
$aButtons[0][0] = 3

$aButtons[1][0] = 360
$aButtons[1][1] = 10
$aButtons[1][2] = 14
$aButtons[1][3] = 19
$aButtons[1][4] = $hImageButton_Back
$aButtons[1][5] = $hImageButton_Back
$aButtons[1][6] = $hImageButton_BackHover
$aButtons[1][7] = "_Back"

$aButtons[2][0] = 380
$aButtons[2][1] = 10
$aButtons[2][2] = 14
$aButtons[2][3] = 19
$aButtons[2][4] = $hImageButton_Next
$aButtons[2][5] = $hImageButton_Next
$aButtons[2][6] = $hImageButton_NextHover
$aButtons[2][7] = "_Next"

$aButtons[3][0] = 300
$aButtons[3][1] = 170
$aButtons[3][2] = 88
$aButtons[3][3] = 22
$aButtons[3][4] = $hImageButton_Read
$aButtons[3][5] = $hImageButton_Read
$aButtons[3][6] = $hImageButton_ReadHover
$aButtons[3][7] = "_Read"

$Timer = TimerInit()

_Update()
_ReDraw()

GUISetOnEvent($GUI_EVENT_CLOSE, "_Exit")
GUISetOnEvent($GUI_EVENT_RESTORE, "WM_PAINT")
GUIRegisterMsg($WM_PAINT, "WM_PAINT")

GUICtrlSetOnEvent($cPolitik, "_ChangeType")
GUICtrlSetOnEvent($cWirtschaft, "_ChangeType")
GUICtrlSetOnEvent($cKultur, "_ChangeType")
GUICtrlSetOnEvent($cRecht, "_ChangeType")
GUICtrlSetOnEvent($cWissenschaft, "_ChangeType")
GUICtrlSetOnEvent($cUmwelt, "_ChangeType")
GUICtrlSetOnEvent($cMedien, "_ChangeType")
GUICtrlSetOnEvent($cArbeit, "_ChangeType")
GUICtrlSetOnEvent($cComputer, "_ChangeType")
GUICtrlSetOnEvent($cSport, "_ChangeType")
GUICtrlSetOnEvent($cCredits, "_ShowCredits")

While Sleep(50)
	_ButtonUpdate($aButtons)
WEnd

Func _ChangeType()
	Switch $GUI_CHECKED
		Case BitAND(GUICtrlRead($cPolitik), $GUI_CHECKED)
			$sNewsType = "Politik"
		Case BitAND(GUICtrlRead($cWirtschaft), $GUI_CHECKED)
			$sNewsType = "Wirtschaft"
		Case BitAND(GUICtrlRead($cKultur), $GUI_CHECKED)
			$sNewsType = "Kultur"
		Case BitAND(GUICtrlRead($cRecht), $GUI_CHECKED)
			$sNewsType = "Recht"
		Case BitAND(GUICtrlRead($cWissenschaft), $GUI_CHECKED)
			$sNewsType = "Wissenschaft"
		Case BitAND(GUICtrlRead($cUmwelt), $GUI_CHECKED)
			$sNewsType = "Umwelt"
		Case BitAND(GUICtrlRead($cMedien), $GUI_CHECKED)
			$sNewsType = "Medien"
		Case BitAND(GUICtrlRead($cArbeit), $GUI_CHECKED)
			$sNewsType = "Arbeit_und_Soziales"
		Case BitAND(GUICtrlRead($cComputer), $GUI_CHECKED)
			$sNewsType = "Computer"
		Case BitAND(GUICtrlRead($cSport), $GUI_CHECKED)
			$sNewsType = "Sport"
	EndSwitch
	$iCurSel = 1
	_Update()
	_ReDraw()
	WinSetTitle($hWnd, "", "WikiNews - " & $sNewsType)
EndFunc

Func _ReDraw()
	$aInfoString = _GDIPlus_GraphicsMeasureString($hBuffer, $aNews[$iCurSel][0], $hFont, $tLayoutDate, $hFormat)
	$iStringWidth = DllStructGetData($aInfoString[0], "width")
	$tLayoutTitle = _GDIPlus_RectFCreate($iStringWidth + 6, 13, 340 - $iStringWidth + 3, 15)

	_GDIPlus_GraphicsDrawImageRect($hBuffer, $hImageBG, 0, 0, 400, 200)

	_GDIPlus_GraphicsDrawStringEx($hBuffer, $aNews[$iCurSel][0], $hFont, $tLayoutDate, $hFormat, $hBrushDate)
	_GDIPlus_GraphicsDrawStringEx($hBuffer, " - " & _StringFormat($hBuffer, $aNews[$iCurSel][1], $tLayoutTitle, $hFont, $hFormat), $hFont, $tLayoutTitle, $hFormat, $hBrushTitle)
	_GDIPlus_GraphicsDrawStringEx($hBuffer, $aNews[$iCurSel][4], $hFont, $tLayoutNewsText, $hFormat, $hBrushTitle)

	_GDIPlus_GraphicsDrawImageRect($hBuffer, $aNews[$iCurSel][3], 5, 50, 135, 104)

	For $i = 1 To $aButtons[0][0]
		_GDIPlus_GraphicsDrawImageRect($hBuffer, $aButtons[$i][4], $aButtons[$i][0], $aButtons[$i][1], $aButtons[$i][2], $aButtons[$i][3])
	Next

	_GDIPlus_GraphicsDrawImageRect($hGraphic, $hBitmap, 0, 0, 400, 200)
EndFunc   ;==>_ReDraw

Func _Back()
	If TimerDiff($Timer) >= 200 And $iCurSel > 1 Then
		$Timer = TimerInit()
		$iCurSel -= 1
		_ReDraw()
	EndIf
EndFunc   ;==>_Back

Func _Next()
	If TimerDiff($Timer) >= 200 And $iCurSel < $aNews[0][0] Then
		$Timer = TimerInit()
		$iCurSel += 1
		_ReDraw()
	EndIf
EndFunc   ;==>_Next

Func _Read()
	ShellExecute($aNews[$iCurSel][2])
EndFunc

Func _ShowCredits()
	_GDIPlus_GraphicsDrawImageRect($hBuffer, $hImageCredits, 0, 0, 400, 200)
	_GDIPlus_GraphicsDrawImageRect($hGraphic, $hBitmap, 0, 0, 400, 200)
	While Sleep(100)
		$aCursorInfo = GUIGetCursorInfo($hWnd)
		If (IsArray($aCursorInfo)) And $aCursorInfo[2] Then
			_ReDraw()
		    ExitLoop
		EndIf
	WEnd
EndFunc

Func _ButtonUpdate(ByRef $aButtonsInfo)
	$aMousePos = GUIGetCursorInfo($hWnd)
	For $i = 1 To $aButtonsInfo[0][0]
		$iResult = _PtIsInRect($aMousePos[0], $aMousePos[1], $aButtonsInfo[$i][0], $aButtonsInfo[$i][1], $aButtonsInfo[$i][2], $aButtonsInfo[$i][3])
		If $iResult = 1 Then
			If $aButtons[$i][4] <> $aButtons[$i][6] Then
				$aButtonsInfo[$i][4] = $aButtonsInfo[$i][6]
				_ReDraw()
			EndIf
			If MouseGetCursor() <> 0 Then GUISetCursor(0, 1)
			If $aMousePos[2] Then Call($aButtonsInfo[$i][7])
		ElseIf $iResult = 0 And $aButtonsInfo[$i][4] <> $aButtonsInfo[$i][5] Then
			$aButtonsInfo[$i][4] = $aButtonsInfo[$i][5]
			If MouseGetCursor() <> 2 Then GUISetCursor(2, 1)
			_ReDraw()
		EndIf
	Next
EndFunc   ;==>_ButtonUpdate

Func _Update()
	GUISetCursor(1, 1)
	$aNews = _GetNews($sNewsType)
	GUISetCursor(2, 1)
EndFunc   ;==>_Update

Func _StringFormat($hGraphics, $sString, $tLayout, $hFont, $hFormat)
	$aInfo = _GDIPlus_GraphicsMeasureString($hGraphics, $sString, $hFont, $tLayout, $hFormat)
	If StringLen($sString) > $aInfo[1] Then Return StringLeft($sString, $aInfo[1] - 4) & "..."
	Return $sString
EndFunc   ;==>_StringFormat

Func _GetNews($sNewsType)
	GUICtrlSetData($cProgress, 0)
	ControlShow($hWnd, "", $cProgress)
	$sHTML = StringReplace(BinaryToString(InetRead("http://de.wikinews.org/wiki/Portal:" & $sNewsType), 4), @LF, "")
	If $sHTML = "" Then Return SetError(1, 0, 0)
	$aNewsSectionTmp = _StringBetween($sHTML, '<tr style="background: #ffffff;"><td><ul>', '</ul></td></tr>')
	$aDate = _StringBetween($aNewsSectionTmp[0], '<li>', ': <a href="')
	$aString = _StringBetween($aNewsSectionTmp[0], 'title="', '">')
	$aLink = _StringBetween($aNewsSectionTmp[0], '<a href="', '" title="')

	Switch 0
		Case $aNewsSectionTmp, $aDate, $aString, $aLink
			Return SetError(2, 0, 0)
	EndSwitch

	Dim $aNewsReturn[UBound($aLink)][5]
	$aNewsReturn[0][0] = UBound($aLink) - 1

	If IsArray($aNews) Then
		For $i = 1 To $aNews[0][0]
			_GDIPlus_ImageDispose($aNews[$i][3])
		Next
	EndIf

	For $i = 1 To $aNewsReturn[0][0]
		$aNewsReturn[$i][0] = $aDate[$i - 1]
		$aNewsReturn[$i][1] = $aString[$i - 1]
		$aNewsReturn[$i][2] = "http://de.wikinews.org" & $aLink[$i - 1]
		$sHTMLImage = StringReplace(BinaryToString(InetRead($aNewsReturn[$i][2]), 4), @LF, "")
		$aImagesRaw = _StringBetween($sHTMLImage, '<img', '/></a></div>')
		$sTempFile = _TempFile()
		$Check = InetGet(_ImageFilter($aImagesRaw), $sTempFile)
		If $Check = 0 Then
			$aNewsReturn[$i][3] = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\Images\Wiki.png")
		Else
			$aNewsReturn[$i][3] = _GDIPlus_ImageLoadFromFile($sTempFile)
		EndIf
		FileDelete($sTempFile)
		$aNewsTextTmp = _StringBetween($sHTMLImage, '</div><p>', '</p>')
		If $aNewsTextTmp <> 0 Then
		    _DeleteHTML($aNewsTextTmp[0])
			$aNewsReturn[$i][4] = $aNewsTextTmp[0]
		EndIf
		GUICtrlSetData($cProgress, $i * 100 / $aNewsReturn[0][0])
	Next
	ControlHide($hWnd, "", $cProgress)
	Return $aNewsReturn
EndFunc   ;==>_GetNews

Func _DeleteHTML(ByRef $sHTML)
	$sHTML = StringRegExpReplace($sHTML, '<.*?>', "")
	$sHTML = StringReplace($sHTML, '&#160;', "")
EndFunc

Func _ImageFilter($aImagesCheck)
	If Not IsArray($aImagesCheck) Then Return 0
	For $i = 0 To UBound($aImagesCheck) - 1
		$aImageTmp = _StringBetween($aImagesCheck[$i], 'src="', '"')
		$bCheck = True
		For $j = 0 To UBound($aImageFilter) - 1
			If StringInStr($aImageTmp[0], $aImageFilter[$j]) Then $bCheck = False
		Next
		If $bCheck = True Then Return $aImageTmp[0]
	Next
EndFunc   ;==>_ImageFilter

Func _PtIsInRect($iX_Point, $iY_Point, $iX_Rect, $iY_Rect, $iWidth_Rect, $iHeight_Rect)
	If $iX_Point >= $iX_Rect And $iY_Point >= $iY_Rect And $iX_Point <= $iX_Rect + $iWidth_Rect And $iY_Point <= $iY_Rect + $iHeight_Rect Then Return 1
	Return 0
EndFunc   ;==>_PtIsInRect

Func WM_PAINT()
	_GDIPlus_GraphicsDrawImageRect($hGraphic, $hBitmap, 0, 0, 400, 200)
EndFunc

Func _Exit()
	_GDIPlus_GraphicsDispose($hGraphic)
	_GDIPlus_GraphicsDispose($hBuffer)
	_GDIPlus_BitmapDispose($hBitmap)
	_GDIPlus_ImageDispose($hImageBG)
	_GDIPlus_ImageDispose($hImageCredits)
	_GDIPlus_ImageDispose($hImageButton_Back)
	_GDIPlus_ImageDispose($hImageButton_Next)
	_GDIPlus_ImageDispose($hImageButton_Read)
	_GDIPlus_ImageDispose($hImageButton_BackHover)
	_GDIPlus_ImageDispose($hImageButton_NextHover)
	_GDIPlus_ImageDispose($hImageButton_ReadHover)
	For $i = 1 To $aNews[0][0]
		_GDIPlus_ImageDispose($aNews[$i][3])
	Next
	_GDIPlus_BrushDispose($hBrushTitle)
	_GDIPlus_BrushDispose($hBrushDate)
	_GDIPlus_FontDispose($hFont)
	_GDIPlus_FontFamilyDispose($hFamily)
	_GDIPlus_StringFormatDispose($hFormat)
	_GDIPlus_Shutdown()
	Exit
EndFunc   ;==>_Exit